#!/usr/bin/perl

$lastupdate = "March 14, 1997";
# Setzen Sie hier bitte eine 0 um den Testlauf zu umgehen
$TESTING = 0;

############################################################################
#
#		ExamMail
#
#	An automatic exam-marking program
#	Concept by John Oyston
#	Version 2.1
#	December 9, 1996
#       Copyright (C) 1996,1997 by Carsten Schafer and John Oyston
#       uses the cgi-lib.pl library Copyright (c) 1996 Steven E. Brenner
#
#	Ins Deutsche bersetzt von Dan Sepeur
#	URL: http://www.tag4tag.com
# 	Mail: dan@tentacle.de
#
############################################################################

require "./cgi-lib.pl";

# e-mail a file to a specific set of users
# using the /bin/mail ie. emailprog program
sub SendEmail {
    local ($file,$subj,$towhom) = @_;

    system("$emailprog -s \"$subj\" $towhom < $file");
}

# Announce a problem and exits the program
sub Problem {
    local ($reason) = @_;
    print "<CENTER>\n";
    print "Das folgende Problem ist aufgetaucht:<P>\n";
    print "<FONT SIZE=+3><I>$reason</I></FONT><P>\n";
    print "</CENTER>\n";
    print &HtmlBot;
    exit;
}

# strip leading and trailing spaces from the input string
sub strip {
    local ($_) = @_;
    # get rid of leading spaces
    s/^\s//g;
    # get rid of trailing spaces
    s/\s$//g;
    return $_;
}

# try to obtain the --S:qX --E:qX delimited questions from the test form
sub GetQuestion {
    local ($qno) = @_;
    local ($thequest) = "";
    local ($printnow) = 0;
    local ($STR);
    local ($ANS);

    # read in the test_url to find the questions
    open(INF, $test_url) || return "!!!Can't look at $test_url!!!";
    # a simple state machine keeps track of when we should append
    # stuff to the question text stored in $thequest
    while (<INF>)
    {
	$STR = $_;
	$ANS = ($STR =~ /--E:$qno/);
	# break out if we reach the end of the question
	($ANS == 1) && last;
	$ANS = ($STR =~ /--S:$qno/);
	# start saving if we are at the start of it
	if ($ANS == 1)
	    { $printnow = 1; }
	elsif ($printnow == 1)
	    { $thequest = $thequest . $STR; }
    }
    close(INF);
    ($thequest eq "") && return "!!!Frage $qno nicht gefunden!!!";
    return $thequest;
}

sub ReadCfgFile {
    local ($file) = @_;
    local ($STR); local ($type);
    local ($what); local ($param);
    local ($NUMGR); local ($PHRASE);
    local ($QUEST); local ($CFG);

    open(CFG, $file) || &Problem("Keine Antwort fr diesen Test: $file!");
    # set these to 0 so we can detect lack of grades or answers
    $numgrades = 0;
    $numquestions = 0;
    while (<CFG>)
    {
	# get rid of white space
	$STR = &strip($_);
	# get the first three characters in order to find out
	# what kind of entry we are dealing with
	$type = substr($STR, 0, 3);
	($what, $param) = split(/=/, $STR, 2);
	if (substr($type, 0, 1) eq "#")
	{
	    # a comment
	}
	# a definition
	elsif ($type eq "def")
	{
	    if ($what eq "def_explain_url")
		{ $explain_url = $param; }
	    elsif ($what eq "def_scheme")
		{ $scheme = $param; }
	    elsif ($what eq "def_body")
		{ $body = $param; }
	    elsif ($what eq "def_report")
		{ $report = $param; }
	    elsif ($what eq "def_rule")
		{ $rule = $param; }
	    elsif ($what eq "def_marker")
		{ $marker = $param; }
	    elsif ($what eq "def_header")
		{ $testheader = $param; }
	    elsif ($what eq "def_tmppath")
		{ $tmppath = $param; }
	    elsif ($what eq "def_secrange")
		{ $secrange = $param; }
	    elsif ($what eq "def_emailer")
		{ $emailprog = $param; }
	}
	# a grade entry
	elsif ($type eq "grd")
	{
	    $numgrades ++;
	    ($NUMGR,$PHRASE) = split(/,/, $param, 2);
	    $nGrades[$numgrades] = $NUMGR;
	    $wGrades[$numgrades] = $PHRASE;
	}
	# an answer entry
	elsif ($type eq "ans")
	{
	    $numquestions ++;
	    ($QUEST,$ANS) = split(/,/, $param, 2);
	    $Answers{$QUEST} = $ANS;
	    $Questions[$numquestions] = $QUEST;
	}
	else
	{
	    &Problem("Falsche Zeile in der Konfigurationsdatei: <P><PRE>$STR</PRE>");
	}
    }
    close(CFG);
}

# for testing purposes only
# writes a string to the debug file: $dbgfile.
sub DBG {
    local ($what) = @_;

    if ($debugon)
    {
	# append to debug file
	open(DBGO, ">>$dbgfile") || return;
	print DBGO $what;
	close(DBGO);
    }
    return;
}

sub get_date {
    @days = ('Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');
    @months = ('Januar','Februar','Maerz','April','Mai','Juni','Juli',
	      'August','September','Oktober','November','Dezember');

    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    if ($hour < 10)
	{ $hour = "0$hour"; }
    if ($min < 10)
	{ $min = "0$min"; }
    if ($sec < 10)
	{ $sec = "0$sec"; }
    $year += 1900;

    # get rid of -w warnings
    $yday = ""; $isdst = "";

    # construct the string and return it
    return "$days[$wday], $mday $months[$mon], $year um $hour\:$min\:$sec";
}


MAIN:
{
    # the path where test results are kept "" is current directory
    $def_pathtests = "";

    # the rest of the values can be configured through the .cfg files

    # default values for the marking scheme
    # points for: correct answer, guess or blank, incorrect answer
    $def_scheme = "2,0,0";

    # security ID range  default "" = NONE:
    $def_secrange = "";
    # the default marker's email address
    # make sure to escape the @ with a \
    $def_marker = "";
    # name of the default grade phrase file
    $def_grades = "def.grd";
    # the path to the e-mail sender usually /bin/mail
    #$def_emailprog = "/usr/bin/mail";
    $def_emailprog = "/bin/mail";
    # report terseness 0 - less, 2 - most
    $def_report = 1;
    # the contents of the body TAG
    $def_body = "BACKGROUND=\"back.jpg\"";
    # the default horizontal rule  <HR> is the simplest to use here
    $def_rule = "<BR><IMG SRC=\"rbline.gif\"><BR>";
    # the file used for email purposes (process id is appended to this)
    $def_emailfile = "email.";
    # the directory used for temp files --- notice trailing /
    $def_tmppath = "/tmp/";
    # the default word grades
    $i = 1;
    $def_grades[$i ++] = "90,Excellent!";
    $def_grades[$i ++] = "80,Very Good!";
    $def_grades[$i ++] = "70,Good!";
    $def_grades[$i ++] = "60,Fair";
    $def_grades[$i ++] = "50,Poor";
    $def_grades[$i ++] = "0,Fail";
    $def_grades[$i ++] = "";

    # reset variables
    $tmppath = "";
    $body = "";
    $emailprog = "";

    if ($TESTING == 1)
    {
	$debugon = 1;
	$dbgfile = "dbg";
	unlink $dbgfile;
	$def_tmppath = "";
    }
    else
    {
	$debugon = 0;
	#$debugon = 1;
	if ($debugon == 1)
	{
	    $dbgfile = $def_tmppath . "dbg";
	    unlink $dbgfile;
	}
    }

    # Read in all the variables set by the form
    &ReadParse(*input);

    # retrieve variables from the hashed up form
    $email = $input{'email'};

    # these need to be set
    $test_url = $input{'test_url'};
    $testname = $input{'test_name'};
    $name = $input{'name'};

    $testheader = $input{'test_header'};
    $secID = $input{'ID'};

    # reset these
    $scheme = "";
    $rule = "";
    $marker = "";
    $secrange = "";
    $report = "";
    $explain_url = "";

    if ($TESTING == 0)
	{ print &PrintHeader; }

    # if testheader not set we use the testname instead ... blah
    if ($testheader eq "")
	{ $testheader = $testname; }

    # construct the file name for the .cfg file for this test
    $file = $def_pathtests . $testname . ".cfg";

    # read in the cfg file
    &ReadCfgFile($file);

    # use defaults if not in cfg file
    if ($body eq "")
	{ $body = $def_body; }
    if ($secrange eq "")
	{ $secrange = $def_secrange; }
    if ($report eq "")
	{ $report = $def_report; }
    if ($emailprog eq "")
	{ $emailprog = $def_emailprog; }
    if ($tmppath eq "")
	{ $tmppath = $def_tmppath; }
    if ($rule eq "")
	{ $rule = $def_rule; }

    # Print the HTML header
    print <<EOFHEADER;
<html>
<head>
<title>Das Resultat des Tests: $testheader</title>
</head>
<body $body>
<CENTER>
$rule
</CENTER>
EOFHEADER

    # require testname and test_url to be set in the form
    if ($testname eq "" || $test_url eq "")
	{ &Problem("Kein korrektes Testformular!"); }
    if ($secrange ne "")
    {
	($sec_low, $sec_high) = split(/-/, $secrange);
	if ($sec_high eq "")
	    { $sec_high = $sec_low; }

	if ($secID < $sec_low || $secID > $sec_high)
	    { &Problem("Sicherheitsverifizierung!"); }
    }
    if ($name eq "")
	{ &Problem("Sie mssen Ihren namen angeben!"); }

    $curdate = &get_date;

    # use defaults for the marking scheme and the marker's email address
    if ($scheme eq "")
	{ $scheme = $def_scheme; }
    if ($marker eq "")
	{ $marker = $def_marker; }

    ($scoregood, $scoreguess, $scorewrong) = split(/,/, $scheme);

    # make sure we got some answers
    if ($numquestions == 0)
	{ &Problem("Keine Antworten gefunden!"); }

    # set the default grades if necessary
    if ($numgrades == 0)
    {
	for ($i = 1, $numgrades = 1; $def_grades[$i] ne ""; $i ++, $numgrades ++)
	{
	    ($nGrades[$i], $wGrades[$i]) = split(/,/, $def_grades[$i]);
	}
    }
    # reset variables so we can start counting
    $score = 0;
    $maxscore = 0;
    $guesses = 0;
    $wrong = 0;
    $correct = 0;
    # evaluate the quiz
    for ($i = 1; $i <= $numquestions; $i ++)
    {
	$answ = $input{$Questions[$i]};
	$want = $Answers{$Questions[$i]};
	if ($want eq $answ)
	{
	    $score += $scoregood;
	    $correct ++;
	}
	elsif ($answ eq "none" || $answ eq "")
	{
	    $guesses ++;
	    $score += $scoreguess;
	}
	else
	{
	    $wrong ++;
	    $score += $scorewrong;
	}
	$maxscore += $scoregood;
    }
    $pscore = $score;
    # don't allow negative scores for the purpose of percentage calculation
    if ($pscore < 0)
	{ $pscore = 0; }

    $perc = (($pscore * 100) / $maxscore);
    # round up to the nearest integer
    $perc = int($perc + 0.5);
    $grade = "";

    # search for the word grade
    for ($i = 1; $i <= $numgrades; $i ++)
    {
	if ($perc >= $nGrades[$i])
	{
	    $grade = $wGrades[$i];
	    last;
	}
    }
    # start printing the results
    $wrongpr = $wrong;
    # highlight the # of incorrects
    if ($wrong > 0)
	{ $wrongpr = "<FONT COLOR=\"RED\">$wrong</FONT>"; }

    print <<EOFTEXT;
<CENTER>
<h1><I>Resultat des Tests:<BR>
 $testheader </I></h1>
<TABLE border=5>
<tr><td><I>$curdate</I>
</TABLE>
<P>
$rule
<P>
Testresultate fr: <font color="blue" size=+2>$name</font>
<P>
Ihr Punktestand ist: <font size=+2>$score</font>
von <font size=+2>$maxscore</font>
<P>
Dies sind <font size=+2>$perc %</font> -- <font color="green"><B>$grade</B></font>
<P>
<TABLE border=1>
<TR>
    <TH>
    <TH>Korrekt
    <TH>Falsch
    <TH>Nichts
<TR>
    <TD><B>Ihr Punktestand</B>
    <TD align=center>$correct
    <TD align=center>$wrongpr
    <TD align=center>$guesses
<TR>
    <TD><B>Wert</B>
    <TD align=center>$scoregood
    <TD align=center>$scorewrong
    <TD align=center>$scoreguess
</TABLE>
<P>
EOFTEXT
    if ($report > 0 && ($guesses > 0 || $wrong > 0))
    {
	print "<P>\n";
	if ($report > 1)
	{
	    print "<H2>Liste der Fragen und Antworten:</H2>\n";
	}
	else
	{
	    print "<H2>Falsch beantwortete Fragen:</H2>\n";
	}

	print "<TABLE WIDTH=\"80%\" BORDER=2>\n";
	print "<TH>Frage<TH>Ihre Antwort<TH>Korrekte Antwort\n";
	$maxlen = 7;
	for ($i = 1; $i <= $numquestions; $i ++)
	{
	    $want = $Answers{$Questions[$i]};
	    $answ = $input{$Questions[$i]};
	    $len = length($answ);
	    if ($len > $maxlen)
		{ $maxlen = $len; }
	    if ($report < 2 && ($answ eq $want))
		{ next; }
	    $quest = &GetQuestion($Questions[$i]);
	    if ($answ eq "")
		{ $answ = "none"; }
	    # highlight it
	    if ($answ ne $want)
		{ $answ = "<FONT COLOR=\"red\">$answ</FONT>"; }
	    print "<tr><td align=\"left\">$quest<td align=\"center\">$answ<td align=\"center\"><B>$want</B>\n";
	}
	print "</TABLE>\n";
	print "<P>\n";
    }
    print "Diese Resultate wurden per Mail geschickt an <A HREF=mailto:$marker>$marker</A>!<P>\n";

    # construct the e-mail addresses to send the report to
    $emailall = $marker;
    if ( $email ne "" )
    {
	print "Die eMail wird auch an Ihre Adresse geschickt: <a href=\"mailto:$email\">$email</A>.<P>\n";
	$emailall = $emailall . " " . $email;
    }
    if ($explain_url ne "")
	{ print "Schauen Sie bitte auf <A HREF=\"$explain_url\">$explain_url</A> nach einer Beschreibung der Antworten.<P>\n" }
    print "Sie knnen einen Kommentar an <a href=\"mailto:$marker\">$marker</A> schicken.<P>\n";
    print "$rule\n";
    print "<BR><FONT SIZE=-3>Copyright &copy; 1996 by " .
    	"<A HREF=\"http://www.barint.on.ca/~cschafer\">Carsten Schafer</A> <br>Ins Deutsche bersetzt von <a href=http://www.tag4tag.com>Tag -4- Tag</a>" .
	"Last Update: $lastupdate</FONT>\n";
    print "</CENTER>\n";
    # Close the document cleanly.
    print &HtmlBot;

    $rem_IP = $ENV{'REMOTE_ADDR'};
    if ( $rem_IP eq "")
	{ $rem_IP = "Nicht vorhanden"; }
    $rem_host = $ENV{'REMOTE_HOST'};
    if ( $rem_host eq "")
	{ $rem_host = "Nicht vorhanden"; }
    $emailgot = $email;
    if ( $emailgot eq "")
	{ $emailgot = "Nicht angegeben"; }

    # prepare the email file:  $$ is the current process id (s.b. unique)
    $email_out = $tmppath . $def_emailfile . $$;
    open(OUTF, ">$email_out") || &Problem("Kann keine eMail senden!");
    print OUTF <<EOF;

Test:        $testheader ($testname)

Name:        $name
E-mail:      $emailgot
ID:          $secID
Datum:        $curdate
IP:          $rem_IP
Host:        $rem_host

Punktezahl:  $score  von  $maxscore Punkten
Prozentsatz: $perc % -- $grade

Richtig:            $correct 
Falsch:             $wrong 
Keine Antwort:      $guesses 

EOF
    if ($report > 0 && ($guesses > 0 || $wrong > 0))
    {
	# adjust the headers for the maximum size of the right answer
	$want = pack("A" . $maxlen, "Antwort:");
	print OUTF "Frage: $want Ihre Antwort:\n";
	$want = pack("A" . $maxlen, "-------");
	print OUTF "--------- $want ------------\n";
	for ($i = 1; $i <= $numquestions; $i ++)
	{
	    $want = $Answers{$Questions[$i]};
	    $answ = $input{$Questions[$i]};
	    if ($answ eq "")
		{ $answ = "none"; }
	    if ($report < 2 && ($answ eq $want))
		{ next; }
	    # space pad the question answer
	    $quest = pack("A5", $i);
	    # space pad the right answer
	    $want = pack("A" . $maxlen, $want);
	    $answ = pack("A20", $answ);
	    print OUTF "   $quest  $want $answ\n";
	}
    }

    if ($explain_url ne "")
	{ print OUTF "\nVielen dank fr die Benutzung von ExamMail!!.\n" }
    close(OUTF);

    # send e-mail to the person responsible for the test as well
    # as the student (if an e-mail address is provided)
    $subject = "Quiz-Ergebnis fuer $name";
    if ($TESTING == 0)
    {
	&SendEmail($email_out, $subject, $emailall);
    }
    else
    {
	# just append it to the HTML in test mode
	print "<PRE>\n";
	print "TESTE NUR DEN OUTPUT!!!!!! Wenn sie das sehen, setzen Sie TESTING = 0\n\n";
	print "Send Email to: $emailall\n";
	print "Subject:       $subject\n";
	print "Name:          $name\n";
	print "File:          $email_out\n\n";
	open(INF, "$email_out");
	while (<INF>) { print; }
	close(INF);
	print "</PRE>\n";
    }
    # wipe out the temp e-mail file
    unlink $email_out;
}
